/**
 * TLC Tracking API
 * This is the TLC tracking shipments API designed by SINGLETON. You can find out more about Swagger at [Singleton Web Page](http://singleton.com.ar) or on [TLC Tracking Shipment Page](http://production.tlc.singleton.com.ar).
 *
 * OpenAPI spec version: 1.0.0
 * Contact: soporte@singleton.com.ar
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { HttpHeaders } from '@angular/common/http';
import { Observable } from 'rxjs';
import { Carriers } from '../models/carriers';
import { DeletedResponse } from '../models/deletedResponse';
import { Configuration } from '../configuration';
export interface CarriersServiceInterface {
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    /**
    * Add one carrier.
    * Add one carrier.
    * @param Carriers
    */
    addCarrier(Carriers: Carriers, extraHttpRequestParams?: any): Observable<Carriers>;
    /**
    * Delete one carrier.
    * Delete one carrier.
    * @param id id to delete
    */
    deleteCarrier(id: number, extraHttpRequestParams?: any): Observable<DeletedResponse>;
    /**
    * Edit one carrier.
    * Edit one carrier.
    * @param Carriers
    */
    editCarrier(Carriers: Carriers, extraHttpRequestParams?: any): Observable<Carriers>;
    /**
    * Get one carrier.
    * Get one carrier.
    * @param id id to delete
    * @param deleted Get all, daleted, not deleted data. Default not deleted.
    */
    getCarrierById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', extraHttpRequestParams?: any): Observable<Carriers>;
    /**
    * Get all carriers.
    * Get all carriers.
    * @param skip number of item to skip (not included the first)
    * @param limit max records to return (included the last)
    * @param orderBy order by property. Put &#39;-&#39; at the beginning to descendant order.
    * @param filter filter data. NOT SUPPORTED YET.
    * @param deleted Get all, daleted, not deleted data. Default not deleted.
    * @param userId id of user. Only for admin, editor or viewer users.
    */
    getCarriers(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', userId?: number, extraHttpRequestParams?: any): Observable<Array<Carriers>>;
}
