/**
 * TLC Tracking API
 * This is the TLC tracking shipments API designed by SINGLETON. You can find out more about Swagger at [Singleton Web Page](http://singleton.com.ar) or on [TLC Tracking Shipment Page](http://production.tlc.singleton.com.ar).
 *
 * OpenAPI spec version: 1.0.0
 * Contact: soporte@singleton.com.ar
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { HttpHeaders } from '@angular/common/http';
import { Observable } from 'rxjs';
import { DeletedResponse } from '../models/deletedResponse';
import { LoginObject } from '../models/loginObject';
import { Users } from '../models/users';
import { Configuration } from '../configuration';
export interface UsersServiceInterface {
    defaultHeaders: HttpHeaders;
    configuration: Configuration;
    /**
    * Add one User.
    * Add one User.
    * @param HandedOvers
    */
    addUser(HandedOvers: Users, extraHttpRequestParams?: any): Observable<Users>;
    /**
    * Delete one Users.
    * Delete one User.
    * @param id id to delete
    */
    deleteUsers(id: number, extraHttpRequestParams?: any): Observable<DeletedResponse>;
    /**
    * Edit one User.
    * Edit one User.
    * @param User
    */
    editUser(User: Users, extraHttpRequestParams?: any): Observable<Users>;
    /**
    * Get one User.
    * Get one User.
    * @param id id to delete
    * @param deleted Get all, daleted, not deleted data. Default not deleted.
    */
    getUserById(id: number, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', extraHttpRequestParams?: any): Observable<Users>;
    /**
    * Get all Users.
    * Get all Users.
    * @param skip number of item to skip
    * @param limit max records to return
    * @param orderBy order by property.
    * @param filter filter data.
    * @param deleted Get all, daleted, not deleted data. Default not deleted.
    * @param userId id of user. Only for admin, editor or viewer users.
    */
    getUsers(skip: number, limit: number, orderBy?: string, filter?: string, deleted?: 'NOT-DELETED' | 'DELETED' | 'ALL', userId?: number, extraHttpRequestParams?: any): Observable<Array<Users>>;
    /**
    * Logs user into the system
    *
    * @param email The user email for login
    * @param password The password for login in clear text
    */
    login(email: string, password: string, extraHttpRequestParams?: any): Observable<LoginObject>;
    /**
    * Logs out current logged in user session
    *
    */
    logout(extraHttpRequestParams?: any): Observable<string>;
    /**
    * Get user info by token
    *
    */
    verifyToken(extraHttpRequestParams?: any): Observable<LoginObject>;
}
